--Frame Creation
Frame=class(Turbine.UI.Window)
import "JackdawPlugins.BuffFrame.Snapper"

--Data for fill directions
Horizontal=Turbine.UI.Orientation.Horizontal
Vertical=Turbine.UI.Orientation.Vertical

		dir=			{"1) Left, then up",	"2) Right, then down",		"3) Up, then left",	"4) Down, then right",		"5) Left then Down"	, 	"6) Right then up",	"7) Up then right", 	"8) Down then left"	}
		Orent=		{Horizontal,				Horizontal,						Vertical,					Vertical,							Horizontal				,	Horizontal			,		Vertical,				Vertical					}
		RevFill=	{true,						false,								true,							false,								true							,	false					,		true,						false						}

function Frame:Constructor(name,o)

	--Constructs the frame and sets many procs.
	
	self.Window=Turbine.UI.Window()
		self.Window:SetVisible(true)
		self.Window.DragBar = Deusdictum.UI.DragBar( self.Window,name)
		self.Window.DragBar:SetRotator(true)
		self.Window:SetMouseVisible(false)
	
	self.Cover=Turbine.UI.Control()
		self.Cover:SetParent(self.Window)
		self.Cover:SetMouseVisible(false)
		self.Cover:SetZOrder(-5)
		self.Cover:SetVisible(false)
		self.Cover:SetBackColor(Turbine.UI.Color(0.5,1,1,1))
		
	self.CoverPreview=Turbine.UI.Control()
		self.CoverPreview:SetParent(self.Cover)
		self.CoverPreview:SetSize(32,37)
		self.CoverPreview:SetMouseVisible(false)
		self.CoverPreview:SetBackground("JackdawPlugins/BuffFrame/Backdrop.tga")
		self.CoverPreview:SetStretchMode(1)
		
	--When the dragbar is shown (or hidden) the show the cover and sample icon (or hide them)
	self.Window.DragEnable =function(Sender,Args)  self.Cover:SetMouseVisible(true) self.Cover:SetZOrder(10)  self.Cover:SetVisible(true) self.CoverPreview:SetSize(32*self.scale,37*self.scale) self.Window.DragBar:Refresh() end
	self.Window.DragDisable =function(Sender,Args) self.Cover:SetMouseVisible(false) self.Cover:SetZOrder(-5) self.Cover:SetVisible(false)  self.Window.DragBar:Refresh() end
	
	--Rotator changes frame fill orientation
	self.Window.RotateStart =function(Sender,Args)
		local o=self.Window.o+1
	
		if o>8 then o=1 end
		
		Turbine.Shell.WriteLine("This frame now filling to the "..dir[o])
		
		self:SetOrientation(o)
	end
		
	--Resizing functions
	self.Cover.MouseDown=function(sender,args)
		if self.Window.DragBar:IsVisible() then
				Moving=true
		end		
	end
	
	self.Cover.MouseUp =function(sender,args)
		if Moving then 
			Moving=false
		end
	end
	
	self.Cover.MouseMove = function(sender,args)
		if Moving then
			local x,y=self.Window:GetMousePosition()
			
			if self.Window:IsAltKeyDown() then
				--If the alt key is down the number of icons is being sized.
				x=math.ceil(x/(32*self.scale)) y=math.ceil(y/(37*self.scale))
				
				if x<1 then x=1 end
				if y<1 then y=1 end
				if x>12 then x=12 end
				if y>12 then y=12 end
				self.sx=x
				self.sy=y
				
			else
				--otherwise it is the scale of the bar that is being sized.

					--If shift key is down then snap the resize to a grid
					if self.Window:IsShiftKeyDown() then x=math.ceil(x/16)*16 y=math.ceil(y/16)*16 end
					
					if self.Window.o==1 or self.Window.o==2 then
						self.scale=(x/self.sx)/32
					else
						self.scale=(y/self.sy)/37
					end
					if self.scale<0.5 then self.scale=0.5 end
			end
			
			self:Resize()
			self:Reflow()
			--self:CheckVisibility()
		end
	end
	
	self.ListBox = Turbine.UI.ListBox()
	self.ListBox:SetParent( self.Window )
	self.ListBox:SetPosition( 0, 0 )
	self.ListBox:SetMouseVisible(false)
	
	--A couple of functions used by snapper
	function self.Window:GetRight()
		return self:GetWidth()+self:GetLeft()
	end
	function self.Window:GetBottom()
		return self:GetHeight()+self:GetTop()
	end

	self:Snapper()
end

function Frame:SetOrientation(o)
	--Changes the orientation of the window and listbox to default values based on o.
	if o==nil then o=self.Window.o end
	
	self.Window.o=o
	
	if Orent[self.Window.o]==Horizontal then 
		self.ListBox:SetMaxItemsPerLine(self.sx)
	else 
		self.ListBox:SetMaxItemsPerLine(self.sy)
	end
	
	self.ListBox:SetReverseFill( RevFill[o] )

	self.ListBox:SetOrientation( Orent[o])
	
	self.ListBox:SetPosition(0,0)
	self:Reflow()
end

--Resizes the frame and keeps the scale correct.
function Frame:Resize()
	self.Window				:SetSize	(32*self.sx*self.scale,37*self.sy*self.scale) 
	self.Cover					:SetSize	(32*self.sx*self.scale,37*self.sy*self.scale)
	self.CoverPreview		:SetSize	(32*self.scale,37*self.scale)
	self.ListBox				:SetSize	(32*self.sx*self.scale,37*self.sy*self.scale)
	
	if Orent[self.Window.o]==Horizontal then 
		self.ListBox:SetMaxItemsPerLine(self.sx)
	else 
		self.ListBox:SetMaxItemsPerLine(self.sy)
	end
	
	local width=32*self.scale
	local height=37*self.scale
	for i=1,self.ListBox:GetItemCount() do
		self.ListBox:GetItem(i):SetSize(width,height)
	end
		self.Window.DragBar:Refresh()
end


--Here ready for the custom functions to allow filling from every corner!
function Frame:RemoveItem(i)
	self.ListBox:RemoveItem(i)
	--self:CheckVisibility()
	if self.Window.o>4 then
		self:Reflow()
	end
end

function Frame:AddItem(i)
	self.ListBox:AddItem(i)
	--self:CheckVisibility()
	if self.Window.o>4 then
		self:Reflow()
	end
end

function Frame:CheckVisibility()
--Stops frames being over filled.

--This is remmed out everywhere. I WANT to know where there are more buffs than fit in a frame!

	for i=1,self.ListBox:GetItemCount() do
		self.ListBox:GetItem(i):SetVisible(true)
	end
	for i=self.sx*self.sy+1,self.ListBox:GetItemCount() do
		self.ListBox:GetItem(i):SetVisible(false)
	end
end

function Frame:ClearItems()
	self.ListBox:ClearItems()
	if self.Window.o>4 then
		self:Reflow()
	end
end

--Reflows a frames listbox, dependant on orientation
--This function only needs to be called for orientations 5-8 as there is no default way to fill in those directions.
--This is NOT perfect, but it does the job for now. I am not happy with it to be honest, but can't find a better way without a LOT of changes to the whole plugin. And that ain't worth it.
function Frame:Reflow()
	local o=self.Window.o --Just to save on typing!
	if o<5 then return end	--Just in case it gets through somewhere. Will delete later if un-needed
	--Determine how many rows,columns of icons there are
	local rows=			math.ceil(self.ListBox:GetItemCount()/self.sx)
	local columns=	math.ceil(self.ListBox:GetItemCount()/self.sy)
	local offsety=0
	local offsetx=0
	if o==5 then
		offsety=-(self.sy-rows)*37*self.scale
		if offsety>0 then offsety=0 end
	end
	if o==6 then
		offsety=(self.sy-rows)*37*self.scale
		if offsety<0 then offsety=0 end
	end
	if o==7 then
		offsetx=(columns-self.sx)*32*self.scale
		if offsetx>0 then offsetx=0 end
	end
	if o==8 then
		offsetx=-(columns-self.sx)*32*self.scale
		if offsetx<0 then offsetx=0 end
	end

	self.ListBox:SetPosition(offsetx,offsety)
end	


